%define name nvu
%define version 1.0
%define release 3mdk

%define section Internet/Web Editors
%define title	Nvu	
%define Summary Complete Web authoring system for linux

%define libname %{name}-%{version}
%define mozillalibdir %{_libdir}/%{libname}

#warning: always end release date with 00
# (it should be the hour of build but it is not significant for rpm)
%define date 2005062800


Summary: %{Summary}
Name: %{name}
Version: %{version}
Release: %{release}
Source0: http://glazman.org/%{name}/releases/%{version}/source/%{libname}-sources.tar.bz2
Source1: nvu-rebuild-databases.pl.in.generatechrome.bz2
Source2: nvu-generate-chrome.sh.bz2
Patch0: nvu-freetype2.patch.bz2
Patch1:	nvu-myspell.patch.bz2
Patch4:	nvu-locale.patch.bz2
Patch5: nvu-0.81-systemnspr.patch.bz2
# (fc) 0.81-3mdk quiet extension manager (from Firefox package)
Patch6: nvu-0.81-quietextensions.patch.bz2
# (fc) 0.81-3mdk fix extension manager (from Firefox package)
Patch7: nvu-0.81-fixextensionmanager.patch.bz2
# (fc) 0.81-4mdk fix GIF vulnerability CAN-2005-0399
Patch8: nvu-0.81-gifvulnerability.patch.bz2
# (fc) 1.0.2-2mdk fix JS vulnerability (CVS) (Moz bug #288688)
Patch9:	nvu-0.81-jsvulnerability.patch.bz2
# (fc) 1.0.2-2mdk add env variable to disable GNOME uri handler (Fedora)
Patch10: nvu-0.81-gnome-uriloader.patch.bz2
# fix compilation with gcc 4.0.1
Patch11: nvu-gcc4-fix.patch.bz2
# 64-bit fixes
Patch12: nvu-1.0-64bit-fixes.patch.bz2
# (fc) 1.0-3mdk fix user agent
Patch13: nvu-1.0-mandriva.patch.bz2
# (fc) 1.0-3mdk fix default app for www/ftp
Patch14: nvu-1.0-browser.patch.bz2

License: MPL/LGPL/GPL
Group: Development/Other
Url: http://www.nvu.com
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

BuildRequires:  libjpeg-devel libpng-devel libIDL-devel
BuildRequires:  zip tcsh
BuildRequires:  gtk+2-devel >= 2.2.0
BuildRequires:  gnome-vfs2-devel
BuildRequires:	ImageMagick
BuildRequires: nss-devel
# do not provides mozilla lib
%define _provides_exceptions libgtkembedmoz.so\\|libxp.*
%define _requires_exceptions libgtkembedmoz.so\\|libxp.*

%description
Nvu (pronounced N-view, for a "new view") is a complete Web Authoring 
System that combines web file management and easy-to-use WYSIWYG (What 
You See Is What You Get) web page editing.  Nvu is designed to be 
extremely easy to use, making it ideal for non-technical computer users
who want to create an attractive, professional-looking web site without 
needing to know HTML or web coding

%package devel
Summary:        Nvu development files
Group:          Development/Other
Requires:       %{name} = %{version}
Conflicts:	%mklibname -d js 1

%description devel
Nvu development files


%prep
%setup -q -c %{name}-%{version}
%setup -T -D -n %{name}-%{version}/mozilla
%patch0 -p1
%patch1 -p1
%patch4
%patch5 -p1 -b .systemnspr
# it seems it's already applied in nvu sources
#%patch6 -p1 -b .quietextension
%patch7 -p1 -b .fixextensionmanager
%patch8 -p1 -b .gifvulnerability
%patch9 -p1 -b .jsvulnerability
%patch10 -p1 -b .gnome-uriloader
%patch11  -b .gccfix
%patch12 -p2 -b .64bit-fixes
%patch13 -p1 -b .mandriva
%patch14 -p1 -b .launcher

# let jars get compressed
%__perl -p -i -e 's|\-0|\-9|g' config/make-jars.pl

%build

export MOZILLA_OFFICIAL=1
export BUILD_OFFICIAL=1
export MOZ_STANDALONE_COMPOSER=1
export MOZ_BUILD_DATE=%{date}

%define __libtoolize /bin/true
%define __cputoolize /bin/true

%configure \
  --with-system-nspr \
  --with-system-nss \
  --enable-optimize="$RPM_OPT_FLAGS" --disable-debug --disable-svg --without-system-mng --with-system-png --with-system-jpeg --disable-ldap --disable-mailnews --disable-installer --disable-activex --disable-activex-scripting --disable-tests --disable-oji --disable-necko-disk-cache --enable-single-profile --disable-profilesharing --enable-extensions=wallet,spellcheck,xmlextras,pref,universalchardet,editor/cascades,inspector --enable-image-decoders=png,gif,jpeg --enable-necko-protocols=http,ftp,file,jar,viewsource,res,data --disable-pedantic --disable-short-wchar --enable-xprint --enable-strip-libs --enable-crypto --disable-mathml --with-system-zlib --enable-toolkit=gtk2 --enable-default-toolkit=gtk2 --enable-xft --enable-freetype2 --with-default-mozilla-five-home=%{mozillalibdir}

%make

%install
rm -rf $RPM_BUILD_ROOT
%makeinstall_std

# multiarch files
%multiarch_binaries $RPM_BUILD_ROOT%{_bindir}/nvu-config
%multiarch_includes $RPM_BUILD_ROOT%{_includedir}/%{libname}/mozilla-config.h
%multiarch_includes $RPM_BUILD_ROOT%{_includedir}/%{libname}/js/jsautocfg.h

# menu entry
mkdir -p %buildroot/%_menudir
cat > %buildroot/%_menudir/%name << EOF
?package(%name): \
command="%_bindir/%name" \
needs="x11" \
icon="%name.png" \
section="%section" \
title="%title" \
longtitle="%Summary" \
mimetypes="" accept_url="true" \
multiple_files="false"
EOF

install -m 755 -d $RPM_BUILD_ROOT%{_miconsdir}
install -m 755 -d $RPM_BUILD_ROOT%{_iconsdir}
install -m 755 -d $RPM_BUILD_ROOT%{_liconsdir}
install -m 644   $RPM_BUILD_ROOT%{mozillalibdir}/icons/mozicon16.xpm  $RPM_BUILD_ROOT%{_miconsdir}/%{name}.png
convert -resize 32x32  $RPM_BUILD_ROOT%{mozillalibdir}/icons/mozicon50.xpm $RPM_BUILD_ROOT%{_iconsdir}/%{name}.png 
convert -resize 48x48  $RPM_BUILD_ROOT%{mozillalibdir}/icons/mozicon50.xpm $RPM_BUILD_ROOT%{_liconsdir}/%{name}.png 

# install our rebuild file
bzcat %{SOURCE1} | sed -e "s|mozilla-MOZILLA_VERSION|%{libname}|g;s|LIBDIR|%{_libdir}|g" > \
  $RPM_BUILD_ROOT%{mozillalibdir}/mozilla-rebuild-databases.pl
chmod 755 $RPM_BUILD_ROOT%{mozillalibdir}/mozilla-rebuild-databases.pl

# install our file to rebuild the chrome registry so that we can
# produce nvu extentions in RPM
mkdir -p $RPM_BUILD_ROOT%{mozillalibdir}/chrome/rc.d
bzcat %{SOURCE2} > \
  $RPM_BUILD_ROOT%{mozillalibdir}/chrome/rc.d/generate-chrome.sh

chmod 755 $RPM_BUILD_ROOT%{mozillalibdir}/chrome/rc.d/generate-chrome.sh

# remove unpackaged files
rm -f $RPM_BUILD_ROOT%{mozillalibdir}/{libnspr4.so,libplc4.so,libplds4.so,libnss3.so,libnssckbi.so,libsmime3.so,libsoftokn3.so,libssl3.so,libsoftokn3.chk,TestGtkEmbed}

#ghost files
mkdir -p $RPM_BUILD_ROOT%{mozillalibdir}/extensions
touch $RPM_BUILD_ROOT%{mozillalibdir}/chrome/chrome.rdf
for overlay in {"browser","communicator","editor","inspector","messenger","navigator"}; do
  %{__mkdir_p} $RPM_BUILD_ROOT%{mozillalibdir}/chrome/overlayinfo/$overlay/content
  touch $RPM_BUILD_ROOT%{mozillalibdir}/chrome/overlayinfo/$overlay/content/overlays.rdf
done
touch $RPM_BUILD_ROOT%{mozillalibdir}/extensions/installed-extensions-processed.txt
touch $RPM_BUILD_ROOT%{mozillalibdir}/extensions/Extensions.rdf
touch $RPM_BUILD_ROOT%{mozillalibdir}/components.ini
touch $RPM_BUILD_ROOT%{mozillalibdir}/defaults.ini
touch $RPM_BUILD_ROOT%{mozillalibdir}/components/compreg.dat
touch $RPM_BUILD_ROOT%{mozillalibdir}/components/xpti.dat


%clean
rm -rf $RPM_BUILD_ROOT

%post
%{update_menus}
if [ "$1" == "2" ]; then
  if [ ! -f %{mozillalibdir}/components.ini -o ! -f %{mozillalibdir}/defaults.ini ]; then
	#fix older broken install if needed
	rm -f %{mozillalibdir}/components/*.dat
  fi
fi

export HOME="/root" MOZ_DISABLE_GNOME=1
%{_bindir}/%{name} -register
%{mozillalibdir}/mozilla-rebuild-databases.pl

%postun
%{clean_menus}

%files
%defattr(-,root,root)
%doc LICENSE LEGAL README.txt
%{_bindir}/%{name}
%{_menudir}/%{name}
%{_miconsdir}/%{name}.png
%{_iconsdir}/%{name}.png
%{_liconsdir}/%{name}.png
%{mozillalibdir}
%ghost %{mozillalibdir}/chrome/chrome.rdf
%ghost %{mozillalibdir}/chrome/overlayinfo/browser/content/overlays.rdf
%ghost %{mozillalibdir}/chrome/overlayinfo/communicator/content/overlays.rdf
%ghost %{mozillalibdir}/chrome/overlayinfo/inspector/content/overlays.rdf
%ghost %{mozillalibdir}/chrome/overlayinfo/messenger/content/overlays.rdf
%ghost %{mozillalibdir}/chrome/overlayinfo/navigator/content/overlays.rdf
%ghost %{mozillalibdir}/extensions/Extensions.rdf
%ghost %{mozillalibdir}/extensions/installed-extensions-processed.txt
%ghost %{mozillalibdir}/components.ini
%ghost %{mozillalibdir}/defaults.ini
%ghost %{mozillalibdir}/components/compreg.dat
%ghost %{mozillalibdir}/components/xpti.dat

%files devel
%defattr(-,root,root)
%{_libdir}/pkgconfig/*.pc
%{_bindir}/nvu-config
%multiarch %{multiarch_bindir}/nvu-config
%{_datadir}/idl/%{libname}
%{_includedir}/%{libname}
%multiarch %{multiarch_includedir}/* 

%changelog
* Thu Sep 08 2005 Frederic Crozat <fcrozat@mandriva.com> 1.0-3mdk 
- Patch13: fix user agent
- Patch14 (Debian): fix default application for www/ftp
- Fix buildid
- Use system library when possible
- Change post order, should fix Mdk bug 17146
- add many ghost files

* Wed Sep  7 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-2mdk
- 64-bit fixes from mozilla-firefox branch

* Wed Jun 29 2005 Couriousous <couriousous@mandriva.org> 1.0-1mdk
- 1.0 Final
- Fix compilation with gcc-4.0.1

* Fri Apr 15 2005 Couriousous <couriousous@mandrake.org> 1.0-0.PR1.1mdk
- 1.0PR1

* Tue Apr 05 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.81-5mdk 
- Patch9(CVS): fix JS vulnerability (Moz bug #288688)
- Patch10(Fedora) : add env variable to disable GNOME url handler 
- Update source1 to set HOME is not set

* Thu Mar 24 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.81-4mdk 
- Patch8: security fix for GIF vulnerability CAN-2005-0399

* Wed Mar 16 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.81-3mdk 
- Patch5: fix compilation with system nspr
- Patch6: quiet extension manager (from Firefox package)
- Patch7: fix extension manager (from Firefox package)
- Use firefox libnspr/libnss
- allow parallel compilation with other moz products

* Tue Feb 15 2005 Couriousous <couriousous@mandrake.org> 0.81-2mdk
- Fix dictionary

* Wed Feb 9 2005 Couriousous <couriousous@mandrake.org> 0.81-1mdk
- New version

* Wed Feb 2 2005 Couriousous <couriousous@mandrake.org> 0.80-1mdk
- New version
- Some spec fix

* Mon Jan 31 2005 Couriousous <couriousous@mandrake.org> 0.70-5mdk
- Multiarch-aware

* Mon Jan 17 2005 Couriousous <couriousous@mandrake.org> 0.70-4mdk
- Autodetect locale

* Tue Jan 06 2005 Couriousous <couriousous@mandrake.org> 0.70-3mdk
- Disable venkman

* Wed Jan 05 2005 Couriousous <couriousous@mandrake.org> 0.70-2mdk
- Fix menu entry

* Wed Jan 05 2005 Couriousous <couriousous@mandrake.org> 0.70-1mdk
- 0.7
- Take a lot of stuff from firefox rpm

* Mon Nov 29 2004 Couriousous <couriousous@sceen.net> 0.60-1mdk
- 0.6

* Wed Nov 24 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.50-6mdk
- fix menu entry (bug #12339)

* Thu Nov 11 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.50-5mdk
- add conflict with the libjs devel package

* Tue Oct 19 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.50-4mdk
- fix rpmlint warnings about uncompressed jar files
- fix provides and requires filters

* Fri Oct 15 2004 Michael Scherer <misc@mandrake.org> 0.50-3mdk 
- filter provides

* Wed Oct 13 2004 Couriousous <couriousous@zarb.org> 0.50-2mdk
- Patch to enable xfs + freetype2 ( from mozilla bugzilla, rediffed )
- Patch imported from mozilla spec. ( OOo myspel dict )

* Thu Oct 12 2004 Couriousous <couriousous@zarb.org> 0.50-1mdk
- First Mandrakelinux release
- Many thanks to saispo !
